"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class FailedCollectionSample(ProtocolElement):
    """
    A sample where there was a failure in collection.     Note: since the
    sample failed at collection, there is no sample ID.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import participant as participant_1_5_0

        return {
            "product": participant_1_5_0.Product,
            "source": participant_1_5_0.SampleSource,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.Product": participant_1_5_0.Product,
            "org.gel.models.participant.avro.SampleSource": participant_1_5_0.SampleSource,
            "org.gel.models.participant.avro.FailedCollectionSample": participant_1_5_0.FailedCollectionSample,
        }

    __slots__ = [
        "maskedPid",
        "participantId",
        "participantUid",
        "product",
        "reasonsForCollectionFailure",
        "sampleType",
        "source",
    ]

    def __init__(
        self,
        maskedPid=None,
        participantId=None,
        participantUid=None,
        product=None,
        reasonsForCollectionFailure=None,
        sampleType=None,
        source=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.FailedCollectionSample model.

        :param maskedPid:
            Masked PID of the sample, if used
        :type maskedPid: None | str
        :param participantId:
            Participant Id of the sample
        :type participantId: None | str
        :param participantUid:
            Participant UId of the sample
        :type participantUid: None | str
        :param product:
            Product of the sample
        :type product: None | Product
        :param reasonsForCollectionFailure:
            List of reasons for failure in collection
        :type reasonsForCollectionFailure: None | list[str]
        :param sampleType:
            This is the unmodified sampleType value (e.g. cord_blood) entered by
            the clinician
        :type sampleType: None | str
        :param source:
            Source of the sample
        :type source: None | SampleSource
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
